<template>
	<v-card>
		<task-list-toolbar @input="loadTasks" />
		<v-container fluid fill-height grid-list-lg>
			<v-layout row wrap align-start justify-start>
				<v-flex xs12 sm6 md4 lg3 v-for="(taskImage, i) in tasksPerImage" :key="i">
					<v-img :src="taskImage[0]" alt="image">
						<task-image :tasks="taskImage[1]" />
					</v-img>
				</v-flex>
				<task-add @input="onAddTask" />
			</v-layout>
		</v-container>
	</v-card>
</template>

<script>
import TaskListToolbar from "@/components/TaskListToolbar";
import TaskImage from "@/components/TaskImage";
import TaskAdd from "@/components/TaskAdd";
import taskService from "@/mixins/TaskService";

export default {
	components: {
		TaskListToolbar,
		TaskImage,
		TaskAdd
	},

	mixins: [taskService],

	data() {
		return {
			tasksPerImage: [],
			currentImageIndex: -1
		};
	},

	mounted() {
		this.loadTasks();
		this.currentImageIndex = 0;
	},

	methods: {
		onAddTask(event) {
			this.sortTasksByImage(event);
		},

		loadTasks() {
			this.taskService.findAll().then(t => this.sortTasksByImage(t));
		},

		sortTasksByImage(tasks) {
			this.tasksPerImage = tasks.reduce((map, task) => {
				if (task.image) {
					if (!map.has(task.image)) {
						map.set(task.image, []);
					}

					map.get(task.image).push(task);
				}
				return map;
			}, new Map());
		}
	}
};
</script>
